Subject: Re: [RFC PATCH v0 1/2] net: bridge: propagate FDB table into hardware

From: Stephen Hemminger <[email-masked]>
Date: Tue, 14 Feb 2012 11:05:04 -0800

On Tue, 14 Feb 2012 10:57:04 -0800
John Fastabend <[email-masked]> wrote:

> On 2/14/2012 5:18 AM, jamal wrote:
> > On Mon, 2012-02-13 at 07:13 -0800, John Fastabend wrote:
> > 
> >> The use case here is multiple VFs but the same solution should work with
> >> multiple PFs as well. FDB controls should be independent of how the ports
> >> are exposed VFs, PFs, VMDQ/queue pairs, macvlan, etc.
> > 
> > Makes sense.
> > 
> >> With events and ADD/DEL/GET FDB controls we can solve both cases. This also
> >> solves Roopa's case with macvlan where she wants to add additional addresses
> >> to macvlan ports.
> > 
> > Not familiar with that issue - I'll prowl the list.
> 
> Roopa was likely on the right track here,
> 
> http://patchwork.ozlabs.org/patch/123064/
> 
> But I think the proper syntax is to use the existing PF_BRIDGE:RTM_XXX
> netlink messages. And if possible drive this without extending ndo_ops.
> 
> An ideal user space interaction IMHO would look like,
> 
> [root@jf-dev1-dcblab iproute2]# ./br/br fdb add 52:e5:62:7b:57:88 dev veth10
> [root@jf-dev1-dcblab iproute2]# ./br/br fdb
> port    mac addr                flags
> veth2   36:a6:35:9b:96:c4       local
> veth4   aa:54:b0:7b:42:ef       local
> veth0   2a:e8:5c:95:6c:1b       local
> veth6   6e:26:d5:43:a3:36       local
> veth0   f2:c1:39:76:6a:fb
> veth8   4e:35:16:af:87:13       local
> veth10  52:e5:62:7b:57:88       static
> veth10  aa:a9:35:21:15:c4       local
> [root@jf-dev1-dcblab iproute2]# ./br/br fdb add dev eth3 to 52:e5:62:7b:57:88
> RTNETLINK answers: Invalid argument

I am going to put bridge (nameclash with br) tool into iproute2 (soon).